import 'package:flutter/cupertino.dart';
import 'package:get/get.dart';
import 'package:getx_extended/export.dart';

import 'rx_visible_startable.dart';

class RxModel<T> extends Rx<T> implements RxVisibleStartable {
  final bool isAutoStart;
  Future<T> Function() source;

  RxModel({
    required this.source,
    required T defaultValue,
    this.isAutoStart = true,
  }) : super(defaultValue) {
    if (isAutoStart) {
      reloadDataSource();
    }
  }

  void onVisibleStart() {
    reloadDataSource();
  }

  Future reloadDataSource() async {
    final data = await source();
    postFrameFuture(() => value = data);
    return data;
  }
}
