import 'package:flutter/material.dart';
import 'package:getx_extended/rx/source/rx_visible_startable.dart';
import 'package:visibility_detector/visibility_detector.dart';

class RxVisiblePage extends StatelessWidget {
  RxVisibleStartable source;
  String identifier;
  Widget child;

  RxVisiblePage({
    required this.source,
    required this.identifier,
    required this.child,
  });

  late bool isStarted = source.isAutoStart;

  @override
  Widget build(BuildContext context) => VisibilityDetector(
        key: Key(identifier),
        onVisibilityChanged: (info) {
          if (isStarted) return;
          source.onVisibleStart();
          isStarted = true;
        },
        child: child,
      );
}
